#Creates a table with the results of the selected graph

namespace eval ::GraphResults {
    variable data
}

#Table content
proc ::GraphResults::FillTable { g} {
    variable data
    variable aux_tab
    variable aux_labels
    variable tab
    variable labels
    
    #Number of rows
    set num_rows [ GiD_Info postprocess get graphs_option NumResults $g]
    set data(nrows) $num_rows
    #X list
    set resultsx [ GiD_Info postprocess get graphs_option ResultsX $g] 
    set resultsx [lindex $resultsx 0]
    set xlist [expr [split $resultsx \0]]
    #Y list
    set resultsy [ GiD_Info postprocess get graphs_option ResultsY $g] 
    set resultsy [lindex $resultsy 0]
    set ylist [expr [split $resultsy \0]]
    
    #Fill the content variable used to fill the table
    #0,0 xcolumn 0,1 ycolumn
    lappend aux_labels 0,0
    lappend aux_labels [ GiD_Info postprocess get graphs_option LabelX $g]
    lappend aux_labels 0,1
    lappend aux_labels [ GiD_Info postprocess get graphs_option LabelY $g]
    for {set i 0} {$i<$num_rows} {incr i} {
	lappend aux_tab $i,0
	lappend aux_tab [lindex $xlist $i]
	lappend aux_tab $i,1
	lappend aux_tab [lindex $ylist $i]
    }
    
    #The content variable must be an array
    array set tab $aux_tab
    array set labels $aux_labels
}

proc ::GraphResults::OnClose { } {
    variable data

    destroy $data(win)
}

proc ::GraphResults::Create { g {w .gid.gresults} } {
    package require Tktable
    variable data
    
    InitWindow $w $g PostGraphResultsWindowGeom ::GraphResults::Create $g
    if { ![winfo exists $w] } return ;
    set def_back [$w cget -background]
    set data(background) [ CCGetRGB $w $def_back]
    set data(activebg) [ CCColorActivo $def_back]
    
    set data(win) $w
    
    FillTable $g

    #Create the tables
    ttk::frame $w.fr
    table $w.fr.tab2 -rows 1 -cols 2 -variable ::GraphResults::labels
    table $w.fr.tab -rows $::GraphResults::data(nrows) -cols 2 -variable ::GraphResults::tab -yscrollcommand "$w.fr.scrolly set"
    
    ttk::scrollbar $w.fr.scrolly -command "$w.fr.tab2 yview" -orient vertical

    $w.fr.tab2 width 0 20 1 20
    $w.fr.tab width 0 20 1 20
    
    #Buttons
    set cmd [ttk::frame $w.cmd -style botonesinferiores.TFrame]
    #set cmd [frame $w.cmd -background $data(activebg)]
    ttk::button $cmd.close -text [_ "Close"] -underline 0 -command ::GraphResults::OnClose -takefocus 0
    
    grid $w.cmd.close -pady 6 -sticky nsew
    pack $w.cmd -side bottom -expand false
    grid $w.fr.tab2 -row 1 -column 1 -sticky nsew
    grid $w.fr.tab -row 2 -column 1 -sticky nsew
    grid $w.fr.scrolly -row 2 -column 2 -sticky ns
    grid rowconfigure $w.fr 2 -weight 1
    pack $w.fr
    
    bind $w <Alt-c> "::GraphResults::OnClose"
    bind $w <Escape> "::GraphResults::OnClose"
    focus $w
}
